#!/usr/bin/perl

use HTML::HTMLDoc;
use LWP::Simple;
use CGI::Carp "fatalsToBrowser";
use CGI qw(:standard);
#use CGI;
use Digest::MD5 qw(md5 md5_hex md5_base64);
use lib::MARC;
#use lib::PDF;
use strict;

use vars qw(
			$ENV
			%conf
			%MARC_config
			$cgi
			$MARC
			$content_type
			$DEBUG
			$DEBUG_STRING
			);

use subs qw(

			);

$cgi = new CGI;
			
# Set to 1 for debugging information						
$DEBUG = 1;
$DEBUG_STRING = "";

if($DEBUG) {
	$DEBUG_STRING .= "CGI dump:\n";
	foreach ($cgi->param())
	{
		$DEBUG_STRING .= "$_ = ".$cgi->param($_)."\n";
	}
	$DEBUG_STRING .= "\n";
}

%conf = lib::MARC->conf_parser("../config") or die ("Cannot open config-file: $!");

lib::MARC->dbInit(%conf);

if($cgi->param('id') && $cgi->param('auth') && $cgi->param('perl_id') && $cgi->param('perl_auth') && lib::MARC->verify_session($cgi, %conf) && lib::MARC->verify_request($cgi, %conf))
{

	#my $raw_html = get('http://www.fi');
	my $raw_html = get($cgi->param('from_url'));

	my $htmldoc = new HTML::HTMLDoc();

	if(!$cgi->param('landscape') or $cgi->param('landscape') != 'false')
	{
		$htmldoc->landscape();
		$htmldoc->set_top_margin(2, 'cm');
		$htmldoc->set_bottom_margin(2, 'cm');
		$htmldoc->set_right_margin(2, 'cm');
		$htmldoc->set_left_margin(2, 'cm');
	}
	else
	{
		$htmldoc->set_top_margin(1, 'cm');
		$htmldoc->set_bottom_margin(1, 'cm');
		$htmldoc->set_right_margin(2, 'cm');
		$htmldoc->set_left_margin(2, 'cm');
	}

	$htmldoc->set_html_content($raw_html);

	$htmldoc->_set_doc_config('footer', './D');

	#print $cgi->header('text/html');

	#print $cgi-param('from_url');
	#print "RAW: ".$raw_html;
	#exit;

    $htmldoc->set_bodyfont("Arial");
	$htmldoc->set_fontsize(9);

	if($conf{'using_distro'} eq '1' && $ENV{'HTTP_USER_AGENT'} eq $conf{'distro_user_agent'}) {
        $content_type = 'application/postscript';
		$htmldoc->set_output_format('ps');
	} else {
		$content_type = 'application/pdf';
		$htmldoc->set_output_format('pdf');
	}

	my $pdf = $htmldoc->generate_pdf();

	if(!$htmldoc->error())
	{
		print $cgi->header($content_type);
		print $pdf->to_string();
	}
	else
	{
		print $cgi->header('text/html');
		print $htmldoc->error();
	}
}
else
{
	print $cgi->header('text/plain');
	print $DEBUG_STRING;
	print "You should not be here, right?";
}

